OGRE: Ogre::DataStream Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::DataStream Class Referenceabstract
Core » Resources

General purpose class used for encapsulating the reading and writing of data. More...

`#include <OgreDataStream.h>`

Inheritance diagram for Ogre::DataStream:
[legend]

## Public Types
enum | AccessMode { READ = 1 , WRITE = 2 }

## Public Member Functions
| DataStream (const String &name, uint16 accessMode=READ)
| Constructor for creating named streams.
| DataStream (uint16 accessMode=READ)
| Constructor for creating unnamed streams.
virtual | ~DataStream ()
virtual void | close (void)=0
| Close the stream; this makes further operations invalid.
virtual bool | eof (void) const =0
| Returns true if the stream has reached the end.
uint16 | getAccessMode () const
| Gets the access mode of the stream.
virtual String | getAsString (void)
| Returns a String containing the entire stream.
virtual String | getLine (bool trimAfter=true)
| Returns a String containing the next line of data, optionally trimmed for whitespace.
const String & | getName (void)
| Returns the name of the stream, if it has one.
virtual bool | isReadable () const
| Reports whether this stream is readable.
virtual bool | isWriteable () const
| Reports whether this stream is writeable.
template<typename T>
DataStream & | operator>> (T &val)
virtual size_t | read (void *buf, size_t count)=0
| Read the requisite number of bytes from the stream, stopping at the end of the file.
virtual size_t | readLine (char *buf, size_t maxCount, const String &delim="\n")
| Get a single line from the stream.
virtual void | seek (size_t pos)=0
| Repositions the read point to a specified byte.
size_t | size (void) const
| Returns the total size of the data to be read from the stream, or 0 if this is indeterminate for this stream.
virtual void | skip (long count)=0
| Skip a defined number of bytes.
virtual size_t | skipLine (const String &delim="\n")
| Skip a single line from the stream.
virtual size_t | tell (void) const =0
| Returns the current byte offset from beginning.
virtual size_t | write (const void *buf, size_t count)
| Write the requisite number of bytes from the stream (only applicable to streams that are not read-only).

## Detailed Description

General purpose class used for encapsulating the reading and writing of data.

This class performs basically the same tasks as std::basic_istream, except that it does not have any formatting capabilities, and is designed to be subclassed to receive data from multiple sources, including libraries which have no compatibility with the STL's stream interfaces. As such, this is an abstraction of a set of wrapper classes which pretend to be standard stream classes but can actually be implemented quite differently.

  Generally, if a plugin or application provides an ArchiveFactory, it should also provide a DataStream subclass which will be used to stream data out of that Archive implementation, unless it can use one of the common implementations included.

Note
  Ogre makes no guarantees about thread safety, for performance reasons. If you wish to access stream data asynchronously then you should organise your own mutexes to avoid race conditions.

## Member Enumeration Documentation

## ◆ AccessMode

enum Ogre::DataStream::AccessMode

Enumerator
READ |
WRITE |

## Constructor & Destructor Documentation

## ◆ DataStream() [1/2]

Ogre::DataStream::DataStream | ( | uint16 | accessMode = READ | ) |
| inline

Constructor for creating unnamed streams.

References READ.

Referenced by Ogre::MemoryDataStream::MemoryDataStream(), Ogre::MemoryDataStream::MemoryDataStream(), and operator>>().

## ◆ DataStream() [2/2]

Ogre::DataStream::DataStream | ( | const String & | name,
|  | uint16 | accessMode = READ )
| inline

Constructor for creating named streams.

References READ.

## ◆ ~DataStream()

virtual Ogre::DataStream::~DataStream | ( |  | ) |
| inlinevirtual

## Member Function Documentation

## ◆ getName()

const String & Ogre::DataStream::getName | ( | void |  | ) |
| inline

Returns the name of the stream, if it has one.

## ◆ getAccessMode()

uint16 Ogre::DataStream::getAccessMode | ( |  | ) | const
| inline

Gets the access mode of the stream.

## ◆ isReadable()

virtual bool Ogre::DataStream::isReadable | ( |  | ) | const
| inlinevirtual

Reports whether this stream is readable.

References READ.

## ◆ isWriteable()

virtual bool Ogre::DataStream::isWriteable | ( |  | ) | const
| inlinevirtual

Reports whether this stream is writeable.

References WRITE.

## ◆ operator>>()

template<typename T>

DataStream & Ogre::DataStream::operator>> | ( | T & | val | ) |

References DataStream().

## ◆ read()

virtual size_t Ogre::DataStream::read | ( | void * | buf,
|  | size_t | count )
| pure virtual

Read the requisite number of bytes from the stream, stopping at the end of the file.

Parameters

  buf | Reference to a buffer pointer
  count | Number of bytes to read

Returns
  The number of bytes read

Implemented in Ogre::DeflateStream, Ogre::FileHandleDataStream, Ogre::FileStreamDataStream, and Ogre::MemoryDataStream.

## ◆ write()

virtual size_t Ogre::DataStream::write | ( | const void * | buf,
|  | size_t | count )
| inlinevirtual

Write the requisite number of bytes from the stream (only applicable to streams that are not read-only).

Parameters

  buf | Pointer to a buffer containing the bytes to write
  count | Number of bytes to write

Returns
  The number of bytes written

Reimplemented in Ogre::DeflateStream, Ogre::FileHandleDataStream, Ogre::FileStreamDataStream, and Ogre::MemoryDataStream.

## ◆ readLine()

virtual size_t Ogre::DataStream::readLine | ( | char * | buf,
|  | size_t | maxCount,
|  | const String & | delim = "\n" )
| virtual

Get a single line from the stream.

The delimiter character is not included in the data returned, and it is skipped over so the next read will occur after it. The buffer contents will include a terminating character.

Note
  If you used this function, you must open the stream in binary mode, otherwise, it'll produce unexpected results.

Parameters

  buf | Reference to a buffer pointer
  maxCount | The maximum length of data to be read, excluding the terminating character
  delim | The delimiter to stop at

Returns
  The number of bytes read, excluding the terminating character

Reimplemented in Ogre::FileStreamDataStream, and Ogre::MemoryDataStream.

## ◆ getLine()

virtual String Ogre::DataStream::getLine | ( | bool | trimAfter = true | ) |
| virtual

Returns a String containing the next line of data, optionally trimmed for whitespace.

This is a convenience method for text streams only, allowing you to retrieve a String object containing the next line of data. The data is read up to the next newline character and the result trimmed if required.

Note
  If you used this function, you must open the stream in binary mode, otherwise, it'll produce unexpected results.

Parameters

  trimAfter | If true, the line is trimmed for whitespace (as in String.trim(true,true))

## ◆ getAsString()

virtual String Ogre::DataStream::getAsString | ( | void |  | ) |
| virtual

Returns a String containing the entire stream.

This is a convenience method for text streams only, allowing you to retrieve a String object containing all the data in the stream.

## ◆ skipLine()

virtual size_t Ogre::DataStream::skipLine | ( | const String & | delim = "\n" | ) |
| virtual

Skip a single line from the stream.

Note
  If you used this function, you must open the stream in binary mode, otherwise, it'll produce unexpected results.

  delim The delimiter(s) to stop at

Returns
  The number of bytes skipped

Reimplemented in Ogre::MemoryDataStream.

## ◆ skip()

virtual void Ogre::DataStream::skip | ( | long | count | ) |
| pure virtual

Skip a defined number of bytes.

This can also be a negative value, in which case the file pointer rewinds a defined number of bytes.

Implemented in Ogre::DeflateStream, Ogre::FileHandleDataStream, Ogre::FileStreamDataStream, and Ogre::MemoryDataStream.

## ◆ seek()

virtual void Ogre::DataStream::seek | ( | size_t | pos | ) |
| pure virtual

Repositions the read point to a specified byte.

Implemented in Ogre::DeflateStream, Ogre::FileHandleDataStream, Ogre::FileStreamDataStream, and Ogre::MemoryDataStream.

## ◆ tell()

virtual size_t Ogre::DataStream::tell | ( | void |  | ) | const
| pure virtual

Returns the current byte offset from beginning.

Implemented in Ogre::DeflateStream, Ogre::FileHandleDataStream, Ogre::FileStreamDataStream, and Ogre::MemoryDataStream.

## ◆ eof()

virtual bool Ogre::DataStream::eof | ( | void |  | ) | const
| pure virtual

Returns true if the stream has reached the end.

Implemented in Ogre::DeflateStream, Ogre::FileHandleDataStream, Ogre::FileStreamDataStream, and Ogre::MemoryDataStream.

## ◆ size()

size_t Ogre::DataStream::size | ( | void |  | ) | const
| inline

Returns the total size of the data to be read from the stream, or 0 if this is indeterminate for this stream.

Referenced by Ogre::FileStreamDataStream::FileStreamDataStream(), Ogre::FileStreamDataStream::FileStreamDataStream(), Ogre::MemoryDataStream::MemoryDataStream(), Ogre::MemoryDataStream::MemoryDataStream(), Ogre::MemoryDataStream::MemoryDataStream(), and Ogre::MemoryDataStream::MemoryDataStream().

## ◆ close()

virtual void Ogre::DataStream::close | ( | void |  | ) |
| pure virtual

Close the stream; this makes further operations invalid.

Implemented in Ogre::DeflateStream, Ogre::FileHandleDataStream, Ogre::FileStreamDataStream, and Ogre::MemoryDataStream.

The documentation for this class was generated from the following file:

- OgreDataStream.h